Story4/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('story1/', include('story1.urls')),
    path('story5/', include('story5.urls')),
    path('story6/', include('story6.urls')),
    path('story7/', include('story7.urls')),
    path('story8/', include('story8.urls')),
    path('story9/', include('story9.urls')),
]

main/urls.py
from django.urls import path

from . import views

app_name = 'story4'

urlpatterns = [
    path('', views.home, name='home'),
    path('story4/', views.story4, name='story4'),
    path('story4/message/', views.message, name='message'),
    path('story4/more/', views.more, name='more'),
]

story6/urls.py
from django.urls import path

from . import views

app_name = 'story6'

urlpatterns = [
    path('', views.story6, name='story6'),
    path('addPerson/', views.addPerson, name='addPerson'),
    path('addEvent/', views.addEvent, name='addEvent'),
    path('updateEvent/<str:pk>/', views.updateEvent, name='updateEvent'),
    path('removeEvent/<str:pk>/', views.removeEvent, name='removeEvent'),
    path('removeParticipant/<str:pk>/', views.removeParticipant, name='removeParticipant'),
]

main/models.py
from django.db import models

# Create your models here.

story6/models.py
from django.db import models

# Create your models here.

class Orang(models.Model):
    name = models.CharField(max_length=25, null=True)

    def __str__(self):
        return self.name

class Kegiatan(models.Model):
    event = models.CharField(max_length=100, null=True)
    participants = models.ManyToManyField(Orang, blank=True)
    
    def __str__(self):
        return self.event

story6/forms.py
from django.forms import ModelForm
from .models import Kegiatan, Orang
from django.forms.widgets import CheckboxSelectMultiple

class KegiatanForm(ModelForm):
    class Meta:
        model = Kegiatan
        fields = '__all__'
    
    def __init__(self, *args, **kwargs):
        
        super(KegiatanForm, self).__init__(*args, **kwargs)
        
        self.fields["participants"].widget = CheckboxSelectMultiple()
        self.fields["participants"].queryset = Orang.objects.all()


class OrangForm(ModelForm):
    class Meta:
        model = Orang
        fields = '__all__'

main/views.py
from django.shortcuts import render, redirect
from .models import *


def home(request):
    return render(request, 'main/home.html')

def story4(request):
    return render(request, 'main/story4.html')    

def message(request):
    return render(request, 'main/message.html')

def more(request):
    return render(request, 'main/more.html')  

story6/views.py
from django.shortcuts import render, redirect
from .models import *
from .forms import KegiatanForm, OrangForm

def story6(request):
    kegiatan = Kegiatan.objects.all()
    orang = Orang.objects.all()

    context = {'kegiatan' : kegiatan, 'orang' : orang}
    return render(request, 'main/story6.html', context)

def addPerson(request):
    orang = Orang.objects.all()
    form = OrangForm()
    if request.method == 'POST':
        form = OrangForm(request.POST)
        if form.is_valid():
            form.save()
            return redirect('/story6')

    context ={'form' : form, 'orang':orang}

    return render(request, 'main/addPerson.html', context)
    
def addEvent(request):
    kegiatan = Kegiatan.objects.all()
    form = KegiatanForm()
    if request.method == 'POST':
        form = KegiatanForm(request.POST)
        if form.is_valid():
            form.save()
            return redirect('/story6')

    context ={'form' : form, 'kegiatan' : kegiatan, 'query' : 'add event'}

    return render(request, 'main/addEvent.html', context)

def updateEvent(request, pk):
    kegiatans = Kegiatan.objects.all()
    kegiatan = Kegiatan.objects.get(id=pk)
    form = KegiatanForm(instance=kegiatan)

    if request.method == 'POST':
        form = KegiatanForm(request.POST, instance=kegiatan)
        if form.is_valid():
            form.save()
            return redirect('/story6')

    context = {'form' : form, 'kegiatan':kegiatan, 'query':'update event'}
    return render(request, 'main/addEvent.html', context)

def removeEvent(request, pk):
    kegiatan = Kegiatan.objects.get(id=pk)
    context = {'item' : kegiatan, 'query' : 'Event'}

    if request.method == 'POST':
        kegiatan.delete()
        return redirect('/story6')

    return render(request, 'main/removeEv.html', context)

def removeParticipant(request, pk):
    orang = Orang.objects.get(id=pk)
    context = {'item' : orang, 'query' : 'Participant'}

    if request.method == 'POST':
        orang.delete()
        return redirect('/story6')

    return render(request, 'main/removePar.html', context)

story6/templates/main/addEvent.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Chapter 6.2</title>
{% endblock meta %}

{% block content %}
<h5 class="judul" style="text-align: left; padding-left: 0; transform: translateX(5%);">{{query}}</h5>
<form action="" method="POST" style="transform: translateX(5%); width: 95%;">
    {% csrf_token %}
    {{form.as_p}}
    <p style="font-size: 14px;">*Leave it unchecked for all participants if you just want to add the event name</p>
    <a href="{% url 'story6:story6' %}" class="back-remove">Back</a>
    <input type="submit" name="submit" class="button-sendiri">
</form><br><br>
{% endblock %}

{% block foot %}
{% endblock %}

story6/templates/main/addPerson.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Chapter 6.1</title>
{% endblock meta %}

{% block content %}
<h5 class="judul" style="text-align: left; padding-left: 0; transform: translateX(5%);">Add Person</h5>
<div style="transform: translateX(5%); width: 95%;">
    <p style="font-size: 14px">*Max 25 char</p>
    <form action="" method="POST">
        {% csrf_token %}
        {{form.as_p}}
        <a href="{% url 'story6:story6' %}" class="back-remove">Back</a>
        <input type="submit" name="submit" class="button-sendiri"">
    </form><br><br>
</div>
{% endblock %}

{% block foot %}
{% endblock %}

story6/templates/main/removeEv.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Chapter 6.3</title>
{% endblock meta %}

{% block content %}
<h5 class="judul">Removing {{query}}</h5>
<div style="text-align: right; margin-right: 60px; margin-left: 60px;">
<h5>Are you sure  you want to delete {{item}}?</h5>
<form action="{% url 'story6:removeEvent' item.id %}" method="POST">
    {% csrf_token %}
    <a href="{% url 'story6:story6' %}" class="back-remove">Back</a>
    <input type="submit" value="Confirm" class="button-sendiri">
</form>
</div>
{% endblock %}

{% block foot %}
{% endblock %}

story6/templates/main/removePar.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Chapter 6.4</title>
{% endblock meta %}

{% block content %}
<h5 class="judul">Removing {{query}}</h5>
<div style="text-align: right; margin-right: 60px; margin-left: 60px;">
<h5>Are you sure  you want to delete {{item}}?</h5>
<form action="{% url 'story6:removeParticipant' item.id %}" method="POST">
    {% csrf_token %}
    <a href="{% url 'story6:story6' %}" class="back-remove">Back</a>
    <input type="submit" value="Confirm" class="button-sendiri">
</form>
</div>
{% endblock %}

{% block foot %}
{% endblock %}

story6/templates/main/story6.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Chapter Six</title>
{% endblock meta %}

{% block content %}
<h5 class="judul">Upcoming Events</h5>
<hr style="border-top: 5px dashed #102B3E;">
<div style="margin-left: 20px; margin-right: 20px;">
  <!-- <a href="{% url 'story6:addPerson' %}"><button class="button-sendiri">Add Person</button> </a><br><br> -->
    <div class="card bg-light mb-3">
      <div class="card-header"><h5>Participants</h5></div>
      <div class="card-body">
        <p class="card-text">
        {% for org in orang %}
        <a href="{% url 'story6:removeParticipant' org.id %}"><button class="button-sendiri-2"> {{org.name}} </button></a> •
        {% endfor %}
        </p>
        <a href="{% url 'story6:addPerson' %}"><button class="button-sendiri">Add Person</button> </a>
      </div>
    </div>
    <h6>*Click on its name to remove participant</h6>
    <br><br>
  <h5>EVENTS</h5>
  <a href="{% url 'story6:addEvent' %}"><button class="button-sendiri">Add Event</button> </a><br><br>
  <h6>*Make sure your name is on the above list, then click the 'update participant' button below to join my event(s)</h6>
    <div class="row">
      {% for keg in kegiatan %}
      <div class="col-sm-3">
        <div class="card bg-light mb-3">
          <div class="card-header"><h5>{{keg.event}}</h5></div>
          <div class="card-body">
            {% for org in keg.participants.all %}
            <p class="card-text">{{org.name}}</p>
            {% endfor %}
            <a href="{% url 'story6:updateEvent' keg.id %}" style="text-decoration: none;"><button class="button-sendiri" >Update Participant</button> </a>
            <a href="{% url 'story6:removeEvent' keg.id %}" style="text-decoration: none;"><button class="button-sendiri">Remove</button> </a>
          </div>
        </div>
      </div>
      {% endfor %}
    </div>
</div>
<br><br>

{% endblock content %}
{% block foot %}
{% endblock %}